/*
	$Id: AutoDB.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __AutoDB_hpp__
#define __AutoDB_hpp__

#include <librfc/Database.hpp>
#include <librfc/export.h>
#include <librfc/RFCBase.hpp>

class Socket;

BEGIN_RFC_NAMESPACE
class RFC_Export AutoDB : public RFCBase
{
private:
	Database	_db;

	AutoDB( const char* pszSource, const char* pszUserId, const char* pszPassword );
	virtual ~AutoDB();

	friend class DBAutoMgr;
	friend class DB;

protected:
	virtual void dump( std::ostream& os );
	virtual void dump( Socket& skt );
};
END_RFC_NAMESPACE

#endif /* !__AutoDB_hpp__ */
