/*
	$Id: CollectionException.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __COLLECTIONEXCEPTION_HPP__
#define __COLLECTIONEXCEPTION_HPP__

#include <librfc/Exception.hpp>

#define CE_ALREADYMEMBER	1	// If single member of a collection, if multi, member of
								//  this collection
#define CE_MEMBEROFOTHERS	2	// Multi-only, cannot be deleted as still a member of
								//  other collection(s)
#define CE_NOTAMEMBER		3	// Cannot be removed from a collection of which it is
								//  not a member

#include <librfc/export.h>

BEGIN_RFC_NAMESPACE
class RFC_Export CollectionException : public Exception
{
public:
	CollectionException( long lReason ):Exception( "CollectionException", lReason ){}
	virtual ~CollectionException(){}
};
END_RFC_NAMESPACE

#endif /* !__COLLECTIONEXCEPTION_HPP__ */
