/*
	$Id: DBAutoMgr.cpp 1270 2018-12-30 14:29:29Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <librfc/DBAutoMgr.hpp>

#include <librfc/Socket.hpp>


USE_RFC_NAMESPACE

DBAutoMgr::DBAutoMgr()
{
}

DBAutoMgr::~DBAutoMgr()
{
}

void DBAutoMgr::setup( const String& strSource, const String& strUserId, const String& strPassword )
{
	_strDSN = strSource;
	_strUserId = strUserId;
	_strPassword = strPassword;
}

AutoDB* DBAutoMgr::getAutoDB()
{
	return new AutoDB( _strDSN, _strUserId, _strPassword );
}

void DBAutoMgr::freeAutoDB( AutoDB* pdbFree )
{
	delete pdbFree;
}

void DBAutoMgr::dump( std::ostream& os )
{
	os << "@ " << typeid( this ).name() << std::endl
		<< "Src=" << ( _strDSN.isNull() ? "(null)" : (const char*)_strDSN )
		<< " Uid=" << ( _strUserId.isNull() ? "(null)" : (const char*)_strUserId )
		<< " Pwd=" << ( _strPassword.isNull() ? "(null)" : (const char*)_strPassword )
		<< std::endl;
}

void DBAutoMgr::dump( TAG_RFC_NAMESPACE Socket& skt )
{
	skt << "@ " << typeid( this ).name() << "\n"
		<< "Src=" << ( _strDSN.isNull() ? "(null)" : (const char*)_strDSN )
		<< " Uid=" << ( _strUserId.isNull() ? "(null)" : (const char*)_strUserId )
		<< " Pwd=" << ( _strPassword.isNull() ? "(null)" : (const char*)_strPassword )
		<< "\n";
}
