/*
	$Id: Exception.cpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <librfc/Exception.hpp>


USE_RFC_NAMESPACE

Exception::Exception( const char* pszName, long lReason )
{
	if( strlen( pszName ) >= (unsigned long)nMaxExceptionNameLen )
	{
		Throw( "Exception Name Length Exceeded", 0 );
	}
	else
	{
		strcpy( _szName, pszName );
	}

	_lReason = lReason;
}

void TAG_RFC_NAMESPACE Throw( const char* pszName, long lReason )
{
	Exception e( pszName, lReason );
	throw e;
}
