/*
	$Id: FCConfig.cpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <librfc/FCConfig.hpp>

#define FCC__LASTLONG			FCC_TWODIGITSTARTYEAR

USE_RFC_NAMESPACE

const long configLongS[] =	{
								0,				// FCC_VERSIONMAJOR
								1,				// FCC_VERSIONMINOR
								1940			// FCC_TWODIGITSTARTYEAR
							};


#define FCC__LASTSTRING			SE_DEFAULT_TIMESTAMP_FORMAT

const String configStringS[] =	{
									"YYYY-MM-DD",	// SE_DEFAULT_DATE_FORMAT
									"HH:NN:SS",	// SE_DEFAULT_TIME_FORMAT
									"YYYY-MM-DD HH:NN:SS"	// SE_DEFAULT_TIMESTAMP_FORMAT
								};



FCConfig::FCConfig()
{
}

FCConfig configurationGlobal;

FCConfig::~FCConfig()
{
}

long FCConfig::GetFCCLong( long lIndex )
{
	if( ( lIndex < 0 ) || ( lIndex > FCC__LASTLONG ) )
	{
		Throw( "Index out of range", 0 );
	}

	return configLongS[lIndex];
}

String FCConfig::GetFCCString( long lIndex )
{
	if( ( lIndex < 0 ) || ( lIndex > FCC__LASTSTRING ) )
	{
		Throw( "Index out of range", 0 );
	}

	return configStringS[lIndex];
}

long RFC_Export TAG_RFC_NAMESPACE GetFCCLong( long lIndex )
{
	return configurationGlobal.GetFCCLong( lIndex );
}

String RFC_Export TAG_RFC_NAMESPACE GetFCCString( long lIndex )
{
	return configurationGlobal.GetFCCString( lIndex );
}
