/*
	$Id: FCConfig.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __FCCONFIG_HPP__
#define __FCCONFIG_HPP__

#include <librfc/String.hpp>
#include <librfc/Exception.hpp>

#define FCC_VERSIONMAJOR			0
#define FCC_VERSIONMINOR			1
#define FCC_TWODIGITSTARTYEAR		2

#define SE_DEFAULT_DATE_FORMAT		0
#define SE_DEFAULT_TIME_FORMAT		1
#define SE_DEFAULT_TIMESTAMP_FORMAT	2

#include <librfc/export.h>

BEGIN_RFC_NAMESPACE
class FCConfig
{
public:
	FCConfig();
	virtual ~FCConfig();

	long GetFCCLong( long lIndex );
	String GetFCCString( long lIndex );
};

// extern FCConfig g_configurationGlobal;

long RFC_Export GetFCCLong( long lIndex );
String RFC_Export GetFCCString( long lIndex );
END_RFC_NAMESPACE

#endif /* !__FCCONFIG_HPP__ */
