/*
	$Id: MultiCollectable.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MULITCOLLECTABLE_HPP__
#define __MULITCOLLECTABLE_HPP__

#include <librfc/Collection.hpp>

#define ALL_COLLECTIONS	(Collection*)-1

BEGIN_RFC_NAMESPACE
class RFC_Export MultiCollectable : public Collectable
{
private:
	Collection _collectionS;

	class Position : public Collectable
	{
	private:
		Collection* _pcollection;

		Position();
		virtual ~Position();

		friend class MultiCollectable;
	};

protected:
//	virtual Collection* parent() const { return _pParent; }
	virtual void addToCollectionHead( Collection* pcollection );
	virtual void addToCollectionTail( Collection* pcollection );
	virtual Collectable* next( Collection* pcollection );
	virtual Collectable* previous( Collection* pcollection );
	virtual void removeFrom( Collection* pcollection );
	virtual long canIDeleteYou() const;

public:
	MultiCollectable( const String& strKey = String() );
	MultiCollectable( long lDeletionPolicy, const String& strKey = String() );
	virtual ~MultiCollectable();

	virtual void remove( long bDelete = 0 );
	virtual void remove( Collection* pcollection, long bDelete = 0 );
};
END_RFC_NAMESPACE

#endif /* !__MULITCOLLECTABLE_HPP__ */
