/*
	$Id: ODBCEnvironment.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __ODBCEnvironment_h__
#define __ODBCEnvironment_h__

#if defined (_WINDOWS)
#	include <windows.h>
#	include <sql.h>
#	include <sqlext.h>
#	if defined (_DEBUG) && !defined(_NO_ASSERT)
#		include <assert.h>
#		define ASSERT(x) assert(x)
#	else
#		define ASSERT(x)
#	endif
#	include <librfc/export.h>
#elif defined (LINUX)
#	include <stdlib.h>
#	include <stdio.h>
#	include <sql.h>
#	include <sqlext.h>
#	include <sqltypes.h>
#	include <librfc/types.h>
#	include <librfc/export.h>
#endif

#include <librfc/RFCBase.hpp>

BEGIN_RFC_NAMESPACE
class Socket;

class ODBCEnvironment : public RFCBase
{
private:
	SQLHANDLE	_hEnv;
	bool		_bEnvValid;

public:
	ODBCEnvironment();
	virtual ~ODBCEnvironment();

	SQLHANDLE handle();
	bool isEnvValid();

protected:
	virtual void dump( std::ostream& os );
	virtual void dump( Socket& skt );
};

extern ODBCEnvironment _ODBCEnvironment;
END_RFC_NAMESPACE

#endif /* !__ODBCEnvironment_h__ */
