/*
	$Id: StringException.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __STRINGEXCEPTION_HPP__
#define __STRINGEXCEPTION_HPP__

#include <librfc/Exception.hpp>

#define SE_LENGTH				1
#define SE_MEMORY				2
#define SE_SUBSCRIPT			3
#define SE_MASKLENGTH			4
#define SE_INVALIDESCAPE		5
#define SE_FIELD				6
#define SE_NOSUCHVARIABLE		17

#include <librfc/export.h>

BEGIN_RFC_NAMESPACE
class RFC_Export StringException : public Exception
{
public:
	StringException( long lReason ):Exception( "StringException", lReason ){}
	virtual ~StringException(){}
};
END_RFC_NAMESPACE

#endif /* !__STRINGEXCEPTION_HPP__ */
