/*
	$Id: StringList.cpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <librfc/StringList.hpp>

#include <stdlib.h>


USE_RFC_NAMESPACE

StringList::StringIterator::StringIterator( const String& strString )
	: _pnext( NULL ),
	_strString( strString )
{
}

StringList::StringIterator::~StringIterator()
{
	if( _pnext != NULL )
		delete _pnext;
}


StringList::StringList()
	: _pfirst( NULL ),
	_plast( NULL )
{
}

StringList::~StringList()
{
	if( _pfirst != NULL )
		delete _pfirst;
}

void StringList::add( const String& strString )
{
	StringIterator* pnew = new StringIterator( strString );
	if( _pfirst == NULL )
		_pfirst = _plast = pnew;
	else
		_plast = _plast->_pnext = pnew;
}

const String& StringList::next( const StringIterator*& pcurrent )
{
	if( pcurrent == NULL )
		pcurrent = _pfirst;

	if( pcurrent == NULL )
		return String::null;

	const String& strRtn = pcurrent->string();

	pcurrent = pcurrent->next();

	return strRtn;
}
