/*
	$Id: StringList.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __STRINGLIST_HPP__
#define __STRINGLIST_HPP__

#include <librfc/String.hpp>

BEGIN_RFC_NAMESPACE
class StringList
{
	public:
		class StringIterator
		{
			private:
				StringIterator* _pnext;
				String _strString;

			public:
				StringIterator( const String& strString );
				virtual ~StringIterator();

				const String& string() const { return _strString; }
				const StringIterator* next() const { return _pnext; }

			protected:
				friend class StringList;
		};

	private:
		StringIterator* _pfirst;
		StringIterator* _plast;

	public:
		StringList();
		virtual ~StringList();

		void add( const String& strString );
		const String& next( const StringIterator*& pcurrent );
};
END_RFC_NAMESPACE

#endif /* !__STRINGLIST_HPP__ */
