/*
	$Id: Waitable.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __Waitable_hpp__
#define __Waitable_hpp__

#if defined (LINUX)
#	include <pthread.h>
#elif defined (_WINDOWS)
#	include <windows.h>
#endif

#include <librfc/export.h>

BEGIN_RFC_NAMESPACE
class RFC_Export Waitable
{
private:
#if defined (LINUX)
	pthread_mutex_t _mx;
	pthread_cond_t _cd;
#elif defined (_WINDOWS)
	HANDLE _ob;
#endif

public:
	Waitable();
	virtual ~Waitable();

	bool wait( unsigned long ulMilliSeconds = (unsigned long)-1 );
	void signal( bool bBroadcast = false );
};
END_RFC_NAMESPACE

#endif /* !__Waitable_hpp__ */
