/*
	$Id: XMLAttr.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __xmlattr_h__
#define __xmlattr_h__

#include <librfc/XMLUtil.hpp>
#include <librfc/String.hpp>
#include <librfc/RFCBase.hpp>

BEGIN_RFC_NAMESPACE
class XMLNode;
class Socket;

class RFC_Export XMLAttr : public RFCBase
{
private:
	String _strName;
	String _strValue;
	XMLAttr* _psiblingPrev;
	XMLAttr* _psiblingNext;

public:
	XMLAttr( XMLNode* pnode, const String& strName, const String& strValue );
	XMLAttr( XMLNode* pnode, const char*& pszStream );
	virtual ~XMLAttr();

	const String& name() const;
	const String& value() const;
	void value( const String& strValue );

	const String stream() const;

	friend class XMLNode;

protected:
	virtual void dump( std::ostream& os );
	virtual void dump( Socket& skt );
};
END_RFC_NAMESPACE

#endif /* !__xmlattr_h__ */
