/*
	$Id: XMLDefs.h 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __xmldefs_h__
#define __xmldefs_h__

#define ASC_NUL				'\0'
#define ASC_TAB				'\t'
#define ASC_NEWLINE			'\n'
#define ASC_SCOLON			';'
#define ASC_AMPERSAND		'&'
#define ASC_GREATER			'>'
#define ASC_LESS			'<'
#define ASC_EQUAL			'='
#define ASC_DQUOTE			'"'
#define ASC_SPACE			' '
#define ASC_SLASH			'/'
#define ASC_BANG			'!'
#define ASC_QUESTION		'?'


#define NODE_BEGIN			"<"
#define NODE_END			">"
#define NODE_EMPTYEND		"/>"
#define NODE_NAMEEND		" ?/>"
#define NCOM_BEGIN			"<?"
#define NCOM_END			"?>"
#define NPRM_BEGIN			"<!"
#define XML_IGNORE			"\r\n\t "


#define TYPE_NORMAL			ASC_NUL
#define TYPE_COMMENT		ASC_QUESTION
#define TYPE_PARAMETER		ASC_BANG


#define XML_XML				"xml"
#define XML_VERSION			"version"
#define XML_ENCODING		"encoding"
#define XML_DOCTYPE			"DOCTYPE"
#define XML_COMMENTSTART	"!--"
#define XML_COMMENTEND		"-->"


#ifndef __SIZE_TYPE__
//	typedef unsigned int size_t;
#endif

#if defined _WINDOWS
//#	define _snprintf snprintf
#endif

#endif /* !__xmldefs_h__ */
