/*
	$Id: XMLException.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __xmlexception_h__
#define __xmlexception_h__

#include <librfc/Exception.hpp>

#define XE_UNKNOWN					001
#define XE_U_UNTERMINATEDCODE		101
#define XE_U_INVALIDCODE			102
#define XE_U_NOTANODE				103
#define XE_U_INVALIDNODE			104
#define XE_N_NOANONNODES			201
#define XE_N_NOTANODE				203
#define XE_N_INVALIDNODE			204
#define XE_N_MALFORMEDNODE			205
#define XE_N_INVALIDDATA			206
#define XE_N_NODEHASCHILDREN		207
#define XE_A_MALFORMEDATTR			301
#define XE_D_INVALIDSTREAM			401
#define XE_D_MALFORMEDXML           402
#define XE_D_NOSUCHFILE				403
#define XE_D_OUTOFMEMORY			404

#include <librfc/export.h>

BEGIN_RFC_NAMESPACE
class RFC_Export XMLException : public Exception
{
public:
	XMLException( long lReason ):Exception( "XMLException", lReason ){}
	virtual ~XMLException(){}
};
END_RFC_NAMESPACE

#endif /* !__xmlexception_h__ */
