/*
	$Id: XMLSNode.cpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <librfc/XMLNode.hpp>


USE_RFC_NAMESPACE

XMLSNode::XMLSNode()
	: _pnode( NULL ),
	_pnext( NULL )
{
}

XMLSNode::XMLSNode( XMLNode* pnode )
	: _pnode( pnode ),
	_pnext( NULL )
{
}

XMLSNode::~XMLSNode()
{
	if( _pnext != NULL )
		delete _pnext;
}






XMLNodeList::XMLNodeList()
	: _pfirst( NULL ),
	_plast( NULL )
{
}

XMLNodeList::~XMLNodeList()
{
	if( _pfirst != NULL )
		delete _pfirst;
}

void XMLNodeList::clear()
{
	if( _pfirst != NULL )
		delete _pfirst;

	_pfirst = _plast = NULL;
}

XMLNode* XMLNodeList::next( XMLSNode*& piterator )
{
	XMLNode* pRtn = NULL;

	if( piterator == NULL )
		piterator = _pfirst;
	else
		piterator = piterator->_pnext;

	if( piterator != NULL )
		pRtn = piterator->_pnode;

	return pRtn;
}

void XMLNodeList::add( XMLNode* pnode )
{
	XMLSNode* psnode = new XMLSNode( pnode );

	if( _pfirst == NULL )
		_pfirst = _plast = psnode;
	else
		_plast = _plast->_pnext = psnode;
}
