/*
	$Id: XMLUtil.hpp 1205 2018-11-22 18:09:31Z john $

	This file is part of the Revelation Foundation Classes.

	The RFC is Copyright (c) 1989 - 1998, Revelation Software Ltd.
	The RFC is Copyright (c) 1998 - 2018, The 4c Company.

	The RFC is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __xmlutil_h__
#define __xmlutil_h__

#include <librfc/XMLException.hpp>

#include <librfc/export.h>

#include <librfc/XMLDefs.h>
#include <librfc/String.hpp>

BEGIN_RFC_NAMESPACE
class RFC_Export XMLUtil
{
	public:
		static const String XMLDecode( const String& strEncoded );
		static const String XMLEncode( const String& strDecoded );

		static const String& getNode( const String& strSource, bool* pbEmpty = 0 );
};
END_RFC_NAMESPACE

#endif /* !__xmlutil_h__ */
